------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Actions;
with Qt4.Byte_Arrays;
with Qt4.Cursors;
with Qt4.Font_Infos;
with Qt4.Font_Metrics;
with Qt4.Fonts;
with Qt4.Icons;
limited with Qt4.Layouts;
with Qt4.Objects;
with Qt4.Paint_Devices;
with Qt4.Palettes;
with Qt4.Points;
with Qt4.Rects;
with Qt4.Regions;
with Qt4.Size_Policies;
with Qt4.Sizes;
with Qt4.Strings;
limited with Qt4.Styles;
with Qt4.Variants;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Widgets is

   type Q_Widget is limited interface
     and Qt4.Objects.Q_Object
     and Qt4.Paint_Devices.Q_Paint_Device;

   type Q_Widget_Access is
     access all Q_Widget'Class;
   for Q_Widget_Access'Storage_Size use 0;

   type Q_Widget_Pointer is tagged;

   function Accept_Drops
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Accessible_Description
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function Accessible_Name
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   procedure Activate_Window
    (Self : not null access Q_Widget'Class);

   procedure Add_Action
    (Self : not null access Q_Widget'Class;
     Action : not null access Qt4.Actions.Q_Action'Class);

   procedure Adjust_Size
    (Self : not null access Q_Widget'Class);

   function Auto_Fill_Background
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Base_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size;

   procedure Child_At
    (Self : not null access constant Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer);

   procedure Child_At
    (Self : not null access constant Q_Widget'Class;
     P : Qt4.Points.Q_Point);

   function Children_Rect
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect;

   function Children_Region
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Regions.Q_Region;

   procedure Clear_Focus
    (Self : not null access Q_Widget'Class);

   procedure Clear_Mask
    (Self : not null access Q_Widget'Class);

   function Contents_Rect
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect;

   function Context_Menu_Policy
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Context_Menu_Policy;

   function Cursor
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Cursors.Q_Cursor;

   function Effective_Win_Id
    (Self : not null access constant Q_Widget'Class)
       return Qt4.W_Id;

   procedure Ensure_Polished
    (Self : not null access constant Q_Widget'Class);

   function Focus_Policy
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Focus_Policy;

   function Focus_Proxy
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Focus_Widget
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Font
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Fonts.Q_Font;

   function Font_Info
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Font_Infos.Q_Font_Info;

   function Font_Metrics
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Font_Metrics.Q_Font_Metrics;

   function Frame_Geometry
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect;

   function Frame_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size;

   procedure Grab_Keyboard
    (Self : not null access Q_Widget'Class);

   procedure Grab_Mouse
    (Self : not null access Q_Widget'Class);

   procedure Grab_Mouse
    (Self : not null access Q_Widget'Class;
     Cursor : Qt4.Cursors.Q_Cursor);

   function Has_Focus
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Has_Mouse_Tracking
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Height
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   not overriding
   function Height_For_Width
    (Self : not null access constant Q_Widget;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer
         is abstract;

   not overriding
   function Input_Method_Query
    (Self : not null access constant Q_Widget;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant
         is abstract;

   procedure Insert_Action
    (Self : not null access Q_Widget'Class;
     Before : access Qt4.Actions.Q_Action'Class;
     Action : not null access Qt4.Actions.Q_Action'Class);

   function Is_Active_Window
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Ancestor_Of
    (Self : not null access constant Q_Widget'Class;
     Child : not null access constant Qt4.Widgets.Q_Widget'Class)
       return Standard.Boolean;

   function Is_Enabled
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Enabled_To
    (Self : not null access constant Q_Widget'Class;
     Ancestor : not null access Qt4.Widgets.Q_Widget'Class)
       return Standard.Boolean;

   function Is_Full_Screen
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Hidden
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Maximized
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Minimized
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Modal
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Visible
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Visible_To
    (Self : not null access constant Q_Widget'Class;
     Ancestor : not null access Qt4.Widgets.Q_Widget'Class)
       return Standard.Boolean;

   function Is_Window
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Is_Window_Modified
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Layout
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Layouts.Q_Layout'Class;

   function Map_From
    (Self : not null access constant Q_Widget'Class;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point;

   function Map_From_Global
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point;

   function Map_From_Parent
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point;

   function Map_To
    (Self : not null access constant Q_Widget'Class;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point;

   function Map_To_Global
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point;

   function Map_To_Parent
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point;

   function Mask
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Regions.Q_Region;

   function Maximum_Height
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   function Maximum_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size;

   function Maximum_Width
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   function Minimum_Height
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   function Minimum_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size;

   not overriding
   function Minimum_Size_Hint
    (Self : not null access constant Q_Widget)
       return Qt4.Sizes.Q_Size
         is abstract;

   function Minimum_Width
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   procedure Move
    (Self : not null access Q_Widget'Class;
     Pos : Qt4.Points.Q_Point);

   procedure Move
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer);

   function Next_In_Focus_Chain
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Normal_Geometry
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect;

   function Palette
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Palettes.Q_Palette;

   function Parent_Widget
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Pos
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Points.Q_Point;

   function Rect
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect;

   procedure Release_Keyboard
    (Self : not null access Q_Widget'Class);

   procedure Release_Mouse
    (Self : not null access Q_Widget'Class);

   procedure Remove_Action
    (Self : not null access Q_Widget'Class;
     Action : not null access Qt4.Actions.Q_Action'Class);

   procedure Repaint
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Repaint
    (Self : not null access Q_Widget'Class;
     R : Qt4.Rects.Q_Rect);

   procedure Repaint
    (Self : not null access Q_Widget'Class;
     Rng : Qt4.Regions.Q_Region);

   procedure Resize
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Resize
    (Self : not null access Q_Widget'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Restore_Geometry
    (Self : not null access Q_Widget'Class;
     Geometry : Qt4.Byte_Arrays.Q_Byte_Array);

   function Save_Geometry
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Byte_Arrays.Q_Byte_Array;

   procedure Scroll
    (Self : not null access Q_Widget'Class;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer);

   procedure Scroll
    (Self : not null access Q_Widget'Class;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer;
     R : Qt4.Rects.Q_Rect);

   procedure Set_Accept_Drops
    (Self : not null access Q_Widget'Class;
     On : Standard.Boolean);

   procedure Set_Accessible_Description
    (Self : not null access Q_Widget'Class;
     Description : Qt4.Strings.Q_String);

   procedure Set_Accessible_Name
    (Self : not null access Q_Widget'Class;
     Name : Qt4.Strings.Q_String);

   procedure Set_Attribute
    (Self : not null access Q_Widget'Class;
     Attribute : Qt4.Widget_Attribute;
     On : Standard.Boolean
       := True);

   procedure Set_Auto_Fill_Background
    (Self : not null access Q_Widget'Class;
     On : Standard.Boolean);

   procedure Set_Base_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Base_Size
    (Self : not null access Q_Widget'Class;
     Basew : Qt4.Q_Integer;
     Baseh : Qt4.Q_Integer);

   procedure Set_Contents_Margins
    (Self : not null access Q_Widget'Class;
     Left : Qt4.Q_Integer;
     Top : Qt4.Q_Integer;
     Right : Qt4.Q_Integer;
     Bottom : Qt4.Q_Integer);

   procedure Set_Context_Menu_Policy
    (Self : not null access Q_Widget'Class;
     Policy : Qt4.Context_Menu_Policy);

   procedure Set_Cursor
    (Self : not null access Q_Widget'Class;
     Cursor : Qt4.Cursors.Q_Cursor);

   procedure Set_Fixed_Height
    (Self : not null access Q_Widget'Class;
     H : Qt4.Q_Integer);

   procedure Set_Fixed_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Fixed_Size
    (Self : not null access Q_Widget'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Set_Fixed_Width
    (Self : not null access Q_Widget'Class;
     H : Qt4.Q_Integer);

   procedure Set_Focus
    (Self : not null access Q_Widget'Class;
     Reason : Qt4.Focus_Reason);

   procedure Set_Focus_Policy
    (Self : not null access Q_Widget'Class;
     Policy : Qt4.Focus_Policy);

   procedure Set_Focus_Proxy
    (Self : not null access Q_Widget'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Font
    (Self : not null access Q_Widget'Class;
     Font : Qt4.Fonts.Q_Font);

   procedure Set_Geometry
    (Self : not null access Q_Widget'Class;
     R : Qt4.Rects.Q_Rect);

   procedure Set_Geometry
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Set_Layout
    (Self : not null access Q_Widget'Class;
     Layout : not null access Qt4.Layouts.Q_Layout'Class);

   procedure Set_Mask
    (Self : not null access Q_Widget'Class;
     Region : Qt4.Regions.Q_Region);

   procedure Set_Maximum_Height
    (Self : not null access Q_Widget'Class;
     Maxh : Qt4.Q_Integer);

   procedure Set_Maximum_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Maximum_Size
    (Self : not null access Q_Widget'Class;
     Maxw : Qt4.Q_Integer;
     Maxh : Qt4.Q_Integer);

   procedure Set_Maximum_Width
    (Self : not null access Q_Widget'Class;
     Maxw : Qt4.Q_Integer);

   procedure Set_Minimum_Height
    (Self : not null access Q_Widget'Class;
     Minh : Qt4.Q_Integer);

   procedure Set_Minimum_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Minimum_Size
    (Self : not null access Q_Widget'Class;
     Minw : Qt4.Q_Integer;
     Minh : Qt4.Q_Integer);

   procedure Set_Minimum_Width
    (Self : not null access Q_Widget'Class;
     Minw : Qt4.Q_Integer);

   procedure Set_Mouse_Tracking
    (Self : not null access Q_Widget'Class;
     Enable : Standard.Boolean);

   procedure Set_Palette
    (Self : not null access Q_Widget'Class;
     Palette : Qt4.Palettes.Q_Palette);

   procedure Set_Parent
    (Self : not null access Q_Widget'Class;
     Parent : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Size_Increment
    (Self : not null access Q_Widget'Class;
     Inc : Qt4.Sizes.Q_Size);

   procedure Set_Size_Increment
    (Self : not null access Q_Widget'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Set_Status_Tip
    (Self : not null access Q_Widget'Class;
     Tip : Qt4.Strings.Q_String);

   procedure Set_Style
    (Self : not null access Q_Widget'Class;
     Style : not null access Qt4.Styles.Q_Style'Class);

   procedure Set_Tool_Tip
    (Self : not null access Q_Widget'Class;
     Tip : Qt4.Strings.Q_String);

   procedure Set_Updates_Enabled
    (Self : not null access Q_Widget'Class;
     Enable : Standard.Boolean);

   procedure Set_Whats_This
    (Self : not null access Q_Widget'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Window_Icon
    (Self : not null access Q_Widget'Class;
     Icon : Qt4.Icons.Q_Icon);

   procedure Set_Window_Icon_Text
    (Self : not null access Q_Widget'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Window_Role
    (Self : not null access Q_Widget'Class;
     Role : Qt4.Strings.Q_String);

   function Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size;

   not overriding
   function Size_Hint
    (Self : not null access constant Q_Widget)
       return Qt4.Sizes.Q_Size
         is abstract;

   function Size_Increment
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size;

   function Size_Policy
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Size_Policies.Q_Size_Policy;

   procedure Stack_Under
    (Self : not null access Q_Widget'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class);

   function Status_Tip
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function Style
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Styles.Q_Style'Class;

   function Style_Sheet
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function Test_Attribute
    (Self : not null access constant Q_Widget'Class;
     Attribute : Qt4.Widget_Attribute)
       return Standard.Boolean;

   function Tool_Tip
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function Under_Mouse
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   procedure Unset_Cursor
    (Self : not null access Q_Widget'Class);

   procedure Unset_Layout_Direction
    (Self : not null access Q_Widget'Class);

   procedure Update
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Update
    (Self : not null access Q_Widget'Class;
     R : Qt4.Rects.Q_Rect);

   procedure Update
    (Self : not null access Q_Widget'Class;
     Rng : Qt4.Regions.Q_Region);

   procedure Update_Geometry
    (Self : not null access Q_Widget'Class);

   function Updates_Enabled
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean;

   function Visible_Region
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Regions.Q_Region;

   function Whats_This
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function Width
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   function Win_Id
    (Self : not null access constant Q_Widget'Class)
       return Qt4.W_Id;

   function Window
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Window_Icon
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Icons.Q_Icon;

   function Window_Icon_Text
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function Window_Role
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function Window_Title
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String;

   function X
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   function Y
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer;

   function Close
    (Self : not null access Q_Widget'Class)
       return Standard.Boolean;

   procedure Hide
    (Self : not null access Q_Widget'Class);

   procedure Lower
    (Self : not null access Q_Widget'Class);

   procedure Raise_Widget
    (Self : not null access Q_Widget'Class);

   procedure Repaint
    (Self : not null access Q_Widget'Class);

   procedure Set_Disabled
    (Self : not null access Q_Widget'Class;
     Disable : Standard.Boolean);

   procedure Set_Enabled
    (Self : not null access Q_Widget'Class;
     Enable : Standard.Boolean);

   procedure Set_Focus
    (Self : not null access Q_Widget'Class);

   procedure Set_Hidden
    (Self : not null access Q_Widget'Class;
     Hidden : Standard.Boolean);

   procedure Set_Style_Sheet
    (Self : not null access Q_Widget'Class;
     Style_Sheet : Qt4.Strings.Q_String);

   not overriding
   procedure Set_Visible
    (Self : not null access Q_Widget;
     Visible : Standard.Boolean)
       is abstract;

   procedure Set_Window_Modified
    (Self : not null access Q_Widget'Class;
     Value : Standard.Boolean);

   procedure Set_Window_Title
    (Self : not null access Q_Widget'Class;
     Title : Qt4.Strings.Q_String);

   procedure Show
    (Self : not null access Q_Widget'Class);

   procedure Show_Full_Screen
    (Self : not null access Q_Widget'Class);

   procedure Show_Maximized
    (Self : not null access Q_Widget'Class);

   procedure Show_Minimized
    (Self : not null access Q_Widget'Class);

   procedure Show_Normal
    (Self : not null access Q_Widget'Class);

   procedure Update
    (Self : not null access Q_Widget'Class);

   procedure Set_Size_Policy
    (Self  : not null access Q_Widget'Class;
     Value : Qt4.Size_Policies.Q_Size_Policy);

   procedure Set_Tab_Order
    (First  : not null access Qt4.Widgets.Q_Widget'Class;
     Second : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Window_Flags
    (Self  : not null access Q_Widget'Class;
     Value : Qt4.Window_Flags);

   package Q_Widget_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Widget, Q_Widget_Access);

   type Q_Widget_Pointer is
     new Q_Widget_Pointers.Q_Pointer with null record;

end Qt4.Widgets;
